package com.zd.chemical.service;

import java.util.List;
import com.zd.chemical.domain.HxpStock;
import com.zd.chemical.domain.vo.HxpStockDetailVO;
import com.zd.chemical.domain.vo.HxpStockJoinVO;
import com.zd.chemical.domain.vo.HxpStockOutVO;
import com.zd.chemical.domain.vo.HxpStockSearch;
import com.zd.system.api.domain.InventoryTag;

/**
 * 库存管理Service接口
 *
 * @author liubo
 * @date 2022-06-17
 */
public interface IHxpStockService
{
    /**
     * 查询库存管理
     *
     * @param id 库存管理主键
     * @return 库存管理
     */
    public HxpStock selectHxpStockById(Long id);

    /**
     * 查询库存管理列表
     *
     * @param hxpStock 库存管理
     * @return 库存管理集合
     */
    public List<HxpStock> selectHxpStockList(HxpStock hxpStock);

    /**
     * 查询库存管理列表(库存明细)
     *
     * @param hxpStockSearch 库存管理
     * @return 库存管理集合
     */
    public List<HxpStockDetailVO> selectHxpStockListDetail(HxpStockSearch hxpStockSearch);

    /**
     * 查询库存管理列表(入库记录)
     *
     * @param hxpStockSearch 库存管理
     * @return 库存管理集合
     */
    public List<HxpStockJoinVO> selectHxpStockListJoin(HxpStockSearch hxpStockSearch);

    /**
     * 查询库存管理列表(出库记录)
     *
     * @param hxpStockSearch 库存管理
     * @return 库存管理集合
     */
    public List<HxpStockOutVO> selectHxpStockListOut(HxpStockSearch hxpStockSearch);

    /**
     * 新增库存管理
     *
     * @param hxpStock 库存管理
     * @return 结果
     */
    public HxpStock insertHxpStock(HxpStock hxpStock);

    /**
     * 修改库存管理
     *
     * @param hxpStock 库存管理
     * @return 结果
     */
    public int updateHxpStock(HxpStock hxpStock);

    /**
     * 批量删除库存管理
     *
     * @param ids 需要删除的库存管理主键集合
     * @return 结果
     */
    public int deleteHxpStockByIds(Long[] ids);

    /**
     * 删除库存管理信息
     *
     * @param id 库存管理主键
     * @return 结果
     */
    public int deleteHxpStockById(Long id);

    boolean RFIDCheck(InventoryTag tag);

    int selectCountByRfidCode(HxpStock hxpStock);

    void expireCheck();

    void outStock(HxpStock hxpStock);
}
